package com.cisco.ass.distr;

import com.cisco.ass.distr.tools.*;
import com.google.common.base.Stopwatch;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.File;
import java.util.concurrent.TimeUnit;

public class Main {

    private static final Logger LOG = LoggerFactory.getLogger(Main.class);

    public static void main(String[] args) throws Exception {

//        Test t = new ThreadImpl();
//        Test t = new CallableImpl();
//        Test t = new StreamImpl();
        Test t = new RxImpl();
//        Test t = new ScalaImpl();

        Factorization factorization = new FactorizationImpl();
        FileNumberSource source = new FileNumberSource(new File("numbers.txt"));
        Stopwatch stopwatch = Stopwatch.createStarted();

        t.test(source, factorization);

        LOG.info("Running time: {} s", stopwatch.stop().elapsed(TimeUnit.SECONDS));
    }
}
