package com.cisco.ass.distr;

import com.cisco.ass.distr.tools.Factorization;
import com.cisco.ass.distr.tools.NumberSource;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.math.BigInteger;
import java.util.List;
import java.util.concurrent.CountDownLatch;

public class ThreadImpl implements Test {

    private static final Logger LOG = LoggerFactory.getLogger(ThreadImpl.class);

    private final CountDownLatch latch = new CountDownLatch(1);

    @Override
    public void test(final NumberSource source, final Factorization factorization) throws InterruptedException {
        new Thread(() -> {
            for (BigInteger n : source) {
                List<BigInteger> factors = factorization.factor(n);
                LOG.info("Factors: {}", factors);
            }
            latch.countDown();
        }).start();

        latch.await();
    }
}
