package com.cisco.ass.distr
import java.math.BigInteger

import com.cisco.ass.distr.tools.{Factorization, NumberSource}
import com.typesafe.scalalogging.StrictLogging

import scala.collection.JavaConverters._

class ScalaImpl extends Test with StrictLogging {

  override def test(source: NumberSource, factorization: Factorization): Unit =
  source.asScala.par
    .map(n => factorization.factor(n))
    .map(factors =>
      factors.asScala.groupBy(identity)
        .map({case (value,values)=>(value,values.size)})
        .toList
        .sorted(Ordering.by[(BigInteger, Int), BigInteger](x => x._1))
        .map({case (factor,power)=>formatFactorWithPower(factor,power)})
        .mkString(" * ")
    )
    .foreach(x => logger.info("Factors: {}", x))

  private def formatFactorWithPower(factor: BigInteger, power: Integer) =
    if (power == 1) factor.toString
    else s"${factor}^${power}"


}
